"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var useIsomorphicLayoutEffect = typeof window !== "undefined" ? React.useLayoutEffect : React.useEffect;
var isSupported = typeof window !== "undefined" && "matchMedia" in window;
var useMediaQuery = function (query) {
    var queries = Array.isArray(query) ? query : [query];
    var queriesKey = queries.join();
    var _a = React.useState(Array(queries.length).fill(false)), matches = _a[0], setMatches = _a[1];
    useIsomorphicLayoutEffect(function () {
        if (!isSupported) {
            // eslint-disable-next-line no-console
            console.error([
                "UtilityJS: useMediaQuery relies on the `window.matchMedia` API.",
                "Since it is not supported in your browser, we are returning `false`."
            ].join("\n"));
            return;
        }
        var mediaQueries = queries.map(function (query) { return matchMedia(query); });
        // Initial matching
        setMatches(mediaQueries.map(function (mediaQuery) { return mediaQuery.matches; }));
        var unsubscribed = false;
        var changeHandlers = mediaQueries.map(function (mediaQuery) {
            var changeHandler = function (event) {
                if (unsubscribed)
                    return;
                var isMatched = event.matches;
                var queryIndex = mediaQueries.findIndex(function (mediaQuery) { return mediaQuery.media === event.media; });
                setMatches(function (prevMatches) {
                    var clone = __spreadArray([], prevMatches, true);
                    clone[queryIndex] = isMatched;
                    return clone;
                });
            };
            mediaQuery.addEventListener("change", changeHandler);
            return changeHandler;
        });
        return function () {
            unsubscribed = true;
            mediaQueries.forEach(function (mediaQuery, index) {
                mediaQuery.removeEventListener("change", changeHandlers[index]);
            });
        };
    }, [queriesKey]);
    return matches;
};
exports.default = useMediaQuery;
